!= Ĺ, Φ̤ȳΤκΤ߹θ
!
!= Set roughness length, only considering land-ocean contrast
!
! Authors::   Yoshiyuki O. Takahashi
! Version::   $Id: roughlen_landoceancontrast.f90,v 1.3 2011-06-19 11:12:46 yot Exp $
! Tag Name::  $Name: dcpam5-20110911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2008-2009. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module roughlen_landoceancontrast

  ! ⥸塼 ; USE statements
  !

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision.
    &                 STRING     ! ʸ.       Strings.

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify


  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public :: SetRoughLenLandOceanContrast
  public :: RoughLenLandOceanContrastInit


  ! ѿ
  ! Public variables
  !

  ! ѿ
  ! Private variables
  !
  logical, save :: roughlen_landoceancontrast_inited = .false.
                              ! ե饰.
                              ! Initialization flag

  character(*), parameter:: module_name = 'roughlen_landoceancontrast'
                              ! ⥸塼̾.
                              ! Module name
  character(*), parameter:: version = &
    & '$Name: dcpam5-20110911 $' // &
    & '$Id: roughlen_landoceancontrast.f90,v 1.3 2011-06-19 11:12:46 yot Exp $'
                              ! ⥸塼ΥС
                              ! Module version


contains

  !--------------------------------------------------------------------------------------

  subroutine SetRoughLenLandOceanContrast( &
    & xy_SurfCond, &
    & xy_RoughLen  &
    )

    ! ⥸塼 ; USE statements
    !

    ! ʻ
    ! Grid points settings
    !
    use gridset, only: imax, & ! ٳʻ.
                               ! Number of grid points in longitude
      &                jmax, & ! ٳʻ.
                               ! Number of grid points in latitude
      &                kmax    ! ľؿ.
                               ! Number of vertical level


    integer , intent(in   ) :: xy_SurfCond( 0:imax-1, 1:jmax )
    real(DP), intent(inout) :: xy_RoughLen( 0:imax-1, 1:jmax )

    ! ѿ
    ! Work variables
    !
    integer:: i               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in latitude

    ! ǧ
    ! Initialization check
    !
    if ( .not. roughlen_landoceancontrast_inited ) then
      call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
    end if


    do j = 1, jmax
      do i = 0, imax-1

        if( xy_SurfCond(i,j) == 0 ) then
          xy_RoughLen(i,j) = 1.0d-4
        else
          xy_RoughLen(i,j) = 1.0d-1
        end if

      end do
    end do


  end subroutine SetRoughLenLandOceanContrast

  !--------------------------------------------------------------------------------------

  subroutine RoughLenLandOceanContrastInit

    if ( roughlen_landoceancontrast_inited ) return


    !  ; Print
    !
    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )


    roughlen_landoceancontrast_inited = .true.

  end subroutine RoughLenLandOceanContrastInit

  !--------------------------------------------------------------------------------------

end module roughlen_landoceancontrast

